# Week 11
### IMPORTANT:
Don't forget to check your seminar room!

> **This week's quiz can be found here:**  https://go.uwe.ac.uk/cppQuiz
> 
> [This weeks lecture](https://uwe.cloud.panopto.eu/Panopto/Pages/Viewer.aspx?id=22eaa667-dd83-402e-a703-add900f21b1a&instance=Blackboard) and [slides](https://blackboard.uwe.ac.uk/webapps/blackboard/execute/content/file?cmd=view&content_id=_10055046_1&course_id=_358428_1&launch_in_new=true)

💬 There is now a discord. Join the discord if you want to : [https://discord.gg/V559GVJQnK](https://discord.gg/V559GVJQnK "https://discord.gg/V559GVJQnK") 💬
## Working on

### 👉 [WORKSHEET 4](https://gitlab.uwe.ac.uk/ng-renney/cpp-resources/-/blob/main/worksheets/worksheet4/worksheet4.md?ref_type=heads) 👈

- Writing simple programs that use print statements (either 
```std::cout``` or `printf()` is acceptable)
- Using for loops to control the flow of programs
- Continuing to write simple expressions and statements to solve problems
- Making use of variables, literals and common types

## Have already completed ...

- Setup up your own machine for development
- Understand the basics of git for forking, cloning and pushing code.

If you have not already completed this please do so ASAP.

## By the end of the week...

... you should have completed:

- Watching [This weeks lecture](https://uwe.cloud.panopto.eu/Panopto/Pages/Viewer.aspx?id=22eaa667-dd83-402e-a703-add900f21b1a&instance=Blackboard) and [slides](https://blackboard.uwe.ac.uk/webapps/blackboard/execute/content/file?cmd=view&content_id=_10055046_1&course_id=_358428_1&launch_in_new=true)
*  Submitted Worksheet 3
- Attend the new format seminar session **(Please check your timetable as the location changes weekly!)**
- Join the discord if you want to : [https://discord.gg/V559GVJQnK](https://discord.gg/V559GVJQnK "https://discord.gg/V559GVJQnK")
- Attend 2 practicals to work on worksheet 4

...you should be able to:

- Write functions including selecting appropriate return types and arguments
- Make function calls and pass arguments to functions when calling them
- Use existing functions from a library to program more complex tasks
- Use nested loops and conditional statements
- Understand the rules to Conway's Game of Life and observe how it creates complex results
## Resources

- Wikipedia Article on Conways Game of Life [here](https://en.wikipedia.org/wiki/Conway%27s_Game_of_Life)  
- The Game of Life Wiki [here](https://www.conwaylife.com/wiki/Main_Page) is great for finding more advanced patterns etc.
- Guide on using [Command Line Interfaces ](https://gitlab.uwe.ac.uk/ng-renney/cpp-resources/-/blob/main/guides/cli.md?ref_type=heads)
- [Git submissions](https://gitlab.uwe.ac.uk/ng-renney/cpp-resources/-/blob/main/guides/git/git-submissions.md?ref_type=heads)
- [Git Reference](https://gitlab.uwe.ac.uk/ng-renney/cpp-resources/-/blob/main/guides/git/git-reference.md?ref_type=heads)

### External
> Note the following resources are from alternative sources and so not everything shown will align with how we are working (things like using different IDEs and compilers.) They are provided as extra resources for further and more varied explantations on related topics.

- [w3 schools](https://www.w3schools.com/cpp/cpp_output.asp)
- [Derek Banas C++ ](https://www.youtube.com/watch?v=Rub-JsjMhWY&t=2487s)
- [using cout](https://www.youtube.com/watch?v=jVC5r0Fpibc)
- [VERY fast overview of printing](https://youtu.be/MNeX4EGtR5Y?si=1uU6QqdFAFUIaH3x&t=70)

